## mingw-w64-snoregrowl-0.5.0-3.src.tar.zst

=== CMakeLists.txt ===
project( SnoreGrowl )
cmake_minimum_required( VERSION 2.6 )

include(GenerateExportHeader)

option(SNOREGROWL_STATIC "Build snoregrowl statically" OFF)

set(SNOREGROWL_VERSION_MAJOR 0)
set(SNOREGROWL_VERSION_MINOR 5)
set(SNOREGROWL_VERSION_PATCH 0)

if(SNOREGROWL_STATIC)
    set(SNOREGROWL_LINK_MODE STATIC)
    if(MSVC)
        set(SUFFIX "lib")
        foreach(_bt DEBUG RELEASE RELWITHDEBINFO)
            string(REPLACE "/MD" "/MT" CMAKE_CXX_FLAGS_${_bt} ${CMAKE_CXX_FLAGS_${_bt}})
        endforeach(_bt DEBUG RELEASE RELWITHDEBINFO)

        set(CMAKE_EXE_LINKER_FLAGS_RELEASE "/NODEFAULTLIB:libcmt /DEFAULTLIB:msvcrt ${CMAKE_EXE_LINKER_FLAGS_RELEASE}")
        set(CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO "/NODEFAULTLIB:libcmt /DEFAULTLIB:msvcrt ${CMAKE_EXE_LINKER_FLAGS_RELWITHDEBINFO}")
        set(CMAKE_EXE_LINKER_FLAGS_MINSIZEREL "/NODEFAULTLIB:libcmt /DEFAULTLIB:msvcrt ${CMAKE_EXE_LINKER_FLAGS_MINSIZEREL}")
        set(CMAKE_EXE_LINKER_FLAGS_DEBUG "/NODEFAULTLIB:libcmtd /DEFAULTLIB:msvcrtd ${CMAKE_EXE_LINKER_FLAGS_DEBUG}")
    endif()
else()
    set(SNOREGROWL_LINK_MODE SHARED)
endif()

find_package(Threads REQUIRED)

add_subdirectory(src)

=== src/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR})

set( GROWL_NTP_C_SRC    growl.c
                        tcp.c
                        md5.c )

add_library( snoregrowl ${SNOREGROWL_LINK_MODE} ${GROWL_NTP_C_SRC} )
target_link_libraries( snoregrowl PUBLIC ${CMAKE_THREAD_LIBS_INIT})
set_target_properties( snoregrowl   PROPERTIES
                                    VERSION "${SNOREGROWL_VERSION_MAJOR}.${SNOREGROWL_VERSION_MINOR}.${SNOREGROWL_VERSION_PATCH}"
                                    SOVERSION "${SNOREGROWL_VERSION_MAJOR}.${SNOREGROWL_VERSION_MINOR}"
                                    EXPORT_NAME SnoreGrowl)


if(WIN32)
    target_link_libraries( snoregrowl PUBLIC ws2_32)
endif()

generate_export_header(snoregrowl EXPORT_FILE_NAME growl_exports.h EXPORT_MACRO_NAME GROWL_EXPORT)

target_include_directories(snoregrowl PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:include>
    $<INSTALL_INTERFACE:include/snoregrowl/>
)



add_library( snoregrowl++ ${SNOREGROWL_LINK_MODE} growl.cpp )
target_link_libraries( snoregrowl++  snoregrowl ${CMAKE_THREAD_LIBS_INIT})
set_target_properties( snoregrowl++ PROPERTIES
                                    VERSION "${SNOREGROWL_VERSION_MAJOR}.${SNOREGROWL_VERSION_MINOR}.${SNOREGROWL_VERSION_PATCH}"
                                    SOVERSION "${SNOREGROWL_VERSION_MAJOR}.${SNOREGROWL_VERSION_MINOR}"
                                    EXPORT_NAME SnoreGrowl++)

generate_export_header(snoregrowl++ EXPORT_FILE_NAME growl_exports.hpp EXPORT_MACRO_NAME GROWL_CPP_EXPORT)

add_executable( gntp-send gntp-send.c )
target_link_libraries ( gntp-send snoregrowl)

add_executable( gntp-send++ gntp-send.cpp )
target_link_libraries ( gntp-send++ snoregrowl snoregrowl++)

configure_file("${CMAKE_CURRENT_SOURCE_DIR}/SnoreGrowlConfig.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/SnoreGrowlConfig.cmake" @ONLY)
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/SnoreGrowl++Config.cmake.in" "${CMAKE_CURRENT_BINARY_DIR}/SnoreGrowl++Config.cmake" @ONLY)

install(TARGETS snoregrowl EXPORT SnoreGrowlTarget
                            RUNTIME DESTINATION bin
                            LIBRARY DESTINATION lib
                            ARCHIVE DESTINATION lib)


install(TARGETS snoregrowl++  EXPORT SnoreGrowl++Target
                              RUNTIME DESTINATION bin
                              LIBRARY DESTINATION lib
                              ARCHIVE DESTINATION lib)

install(FILES growl.h growl.hpp ${CMAKE_CURRENT_BINARY_DIR}/growl_exports.h ${CMAKE_CURRENT_BINARY_DIR}/growl_exports.hpp DESTINATION include/snoregrowl)

install(EXPORT SnoreGrowlTarget DESTINATION lib/cmake/SnoreGrowl NAMESPACE Snore::)
install(EXPORT SnoreGrowl++Target DESTINATION lib/cmake/SnoreGrowl++ NAMESPACE Snore::)


install(FILES "${CMAKE_CURRENT_BINARY_DIR}/SnoreGrowlConfig.cmake" DESTINATION lib/cmake/SnoreGrowl)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/SnoreGrowl++Config.cmake" DESTINATION lib/cmake/SnoreGrowl++)

=== PKGBUILD ===
# Maintainer: Patrick von Reth <vonreth@kde.org>

_realname=snoregrowl
pkgbase=mingw-w64-${_realname}
pkgname="${MINGW_PACKAGE_PREFIX}-${_realname}"
provides=("${MINGW_PACKAGE_PREFIX}-SnoreGrowl")
replaces=("${MINGW_PACKAGE_PREFIX}-SnoreGrowl")
pkgver=0.5.0
pkgrel=3
pkgdesc="A C and C++ library providing an api to use Growl notifications, based on the GNTP protocol (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32' 'clangarm64')
license=("BSD")
url="https://github.com/Snorenotify/Snorenotify"
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja")
options=(!strip staticlibs !buildflags)
source=("${_realname}-${pkgver}.tar.gz"::"https://github.com/Snorenotify/${_realname}/archive/v${pkgver}.tar.gz")
sha256sums=('5180628ce1c732abfc1001db48302b0d63534a3d62dc50a4655e0b4675a918be')

build() {
  [[ -d "${srcdir}"/build-${MSYSTEM} ]] && rm -rf "${srcdir}"/build-${MSYSTEM}
  mkdir -p "${srcdir}"/build-${MSYSTEM} && cd "${srcdir}"/build-${MSYSTEM}

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
  CXXFLAGS="-D_LIBCPP_ENABLE_CXX17_REMOVED_AUTO_PTR" \
  ${MINGW_PREFIX}/bin/cmake \
    -G"Ninja" \
    -DCMAKE_INSTALL_PREFIX=${MINGW_PREFIX} \
    -DCMAKE_BUILD_TYPE=Release \
    ../${_realname}-${pkgver}

  cmake --build .
}

package() {
  cd ${srcdir}/build-${MSYSTEM}
  DESTDIR=${pkgdir} cmake --install .
}
